function load_roles(dummy_load)
  local roles = global
  if dummy_load then
    roles = {}
  end
  
  roles.rolenames =
  {
    "defender",
    "pioneer",
    "factory",
    "scientist",
    "railway",
    "driver",
    "miner",
    "foundry",
    "chem",
    "power",
    "logistics",
    "electronics",
  }
  
  -- Copy all the permissions defined in game
  roles.input_action = table.deepcopy(defines.input_action)
  
  --Set all roles default permissions to false
  roles.rolespermissions = {}
  for k,v in pairs(roles.rolenames) do
    roles.rolespermissions[v] = game.permissions.create_group(k)
    for k1,v1 in pairs(roles.input_action) do  
      roles.rolespermissions[v].set_allows_action(roles.input_action[v1],false)
    end
  end

  -- For the role, set permissions true
  local function assign_permissions(role,permissions)
    for k,v in pairs(permissions) do
      role.rolespermissions[role].set_allows_action(roles.input_action[v],true)
    end
  end
  
  -- Enable specific permsissions for each role
  assign_permissions("defender",{})
  assign_permissions("pioneer",{})
  assign_permissions("factory",{})
  assign_permissions("scientist",{})
  assign_permissions("railway",{})
  assign_permissions("driver",{})
  assign_permissions("miner",{})
  assign_permissions("foundry",{})
  assign_permissions("chem",{})
  assign_permissions("power",{})
  assign_permissions("logistics",{})
  assign_permissions("electronics",{change_arithmetic_combinator_parameters,
                                    change_decider_combinator_parameters,
                                    change_programmable_speaker_alert_parameters,
                                    change_programmable_speaker_circuit_parameters,
                                    change_programmable_speaker_parameters,
                                    remove_cables,
                                    set_circuit_condition,
                                    set_circuit_mode_of_operation,
                                    switch_constant_combinator_state,
                                    switch_power_switch_state,
                                    wire_dragging,
                                    })

  if dummy_load then
    return roles
  end 
end  